Index: src/Parser/PdbParser.hpp
===================================================================
--- src/Parser/PdbParser.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Parser/PdbParser.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,104 @@
+/*
+ * PdbParser.hpp
+ *
+ *  Created on: Aug 17, 2010
+ *      Author: heber
+ */
+
+#ifndef PDBPARSER_HPP_
+#define PDBPARSER_HPP_
+
+#include <string>
+#include "Parser/FormatParser.hpp"
+
+/**
+ * Known keys for the Pdb line.
+ */
+class PdbKey {
+public:
+  enum PdbDataKey {
+    noKey,
+    x,
+    Id,
+    Type,
+    extType,
+    name,
+    resName,
+    chainID,
+    resSeq,
+    occupancy,
+    tempFactor,
+    segID,
+    charge
+  };
+};
+
+/**
+ * Holds tremolo-specific information which is not store in the atom class.
+ */
+class PdbAtomInfoContainer {
+public:
+  PdbAtomInfoContainer();
+  void set(PdbKey::PdbDataKey key, std::string value);
+  std::string get(PdbKey::PdbDataKey key);
+  std::string name;
+  std::string extType;
+  std::string resName;
+  std::string chainID;
+  std::string resSeq;
+  std::string occupancy;
+  std::string tempFactor;
+  std::string segID;
+  std::string charge;
+};
+
+/**
+ * Loads a tremolo file into the World and saves the World as a tremolo file.
+ */
+class PdbParser : public FormatParser
+{
+public:
+  PdbParser();
+  ~PdbParser();
+  void load(std::istream* file);
+  void save(std::ostream* file);
+
+
+private:
+  void readAtomDataLine(string line);
+  void parseAtomDataKeysLine(string line, int offset);
+  void readNeighbors(std::stringstream* line, int numberOfNeighbors, int atomId);
+  void processNeighborInformation();
+  void adaptImprData();
+  void adaptTorsion();
+  std::string adaptIdDependentDataString(std::string data);
+  bool isUsedField(std::string fieldName);
+  void writeNeighbors(std::ostream* file, int numberOfNeighbors, atom* currentAtom);
+  void saveLine(ostream* file, const atom* currentAtom, const char *name, const int AtomNo, const int ResdueNo);
+  int getAtomId(int atomid) const;
+  void setAtomId(int localatomid, int atomid);
+
+  /**
+   * Map to associate the known keys with numbers.
+   */
+  std::map<std::string, PdbKey::PdbDataKey> knownKeys;
+
+  /**
+   * Data which is currently not stored in atoms but was provided by the input
+   * file.
+   */
+  std::map<int, PdbAtomInfoContainer> additionalAtomData;
+
+  /**
+   * Default additional atom data.
+   */
+  PdbAtomInfoContainer defaultAdditionalData;
+
+  /**
+   * Maps original atom IDs received from the parsed file to atom IDs in the
+   * world.
+   */
+  std::map<int, int> atomIdMap;
+};
+
+#endif /* PDBPARSER_HPP_ */
Index: src/Parser/TremoloParser.cpp
===================================================================
--- src/Parser/TremoloParser.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Parser/TremoloParser.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * TremoloParser.cpp
@@ -6,12 +13,20 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Helpers/Assert.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "TremoloParser.hpp"
 #include "World.hpp"
 #include "atom.hpp"
+#include "bond.hpp"
 #include "element.hpp"
-#include "bond.hpp"
+#include "molecule.hpp"
 #include "periodentafel.hpp"
 #include "Descriptors/AtomIdDescriptor.hpp"
@@ -19,7 +34,8 @@
 #include <vector>
 
+#include <iostream>
+#include <iomanip>
 
 using namespace std;
-using namespace boost;
 
 /**
@@ -75,4 +91,5 @@
 
   usedFields.clear();
+  molecule *newmol = World::getInstance().createMolecule();
   while (file->good()) {
     std::getline(*file, line, '\n');
@@ -84,5 +101,5 @@
     }
     if (line.length() > 0 && line.at(0) != '#') {
-      readAtomDataLine(line);
+      readAtomDataLine(line, newmol);
     }
   }
@@ -99,4 +116,6 @@
  */
 void TremoloParser::save(ostream* file) {
+  DoLog(0) && (Log() << Verbose(0) << "Saving changes to tremolo." << std::endl);
+
   vector<atom*>::iterator atomIt;
   vector<string>::iterator it;
@@ -140,13 +159,13 @@
       case TremoloKey::x :
         // for the moment, assume there are always three dimensions
-        *file << currentAtom->x[0] << "\t";
-        *file << currentAtom->x[1] << "\t";
-        *file << currentAtom->x[2] << "\t";
+        *file << currentAtom->at(0) << "\t";
+        *file << currentAtom->at(1) << "\t";
+        *file << currentAtom->at(2) << "\t";
         break;
       case TremoloKey::u :
         // for the moment, assume there are always three dimensions
-        *file << currentAtom->v[0] << "\t";
-        *file << currentAtom->v[1] << "\t";
-        *file << currentAtom->v[2] << "\t";
+        *file << currentAtom->AtomicVelocity[0] << "\t";
+        *file << currentAtom->AtomicVelocity[1] << "\t";
+        *file << currentAtom->AtomicVelocity[2] << "\t";
         break;
       case TremoloKey::Type :
@@ -154,13 +173,27 @@
         break;
       case TremoloKey::Id :
-        *file << currentAtom->getId() << "\t";
+        *file << currentAtom->getId()+1 << "\t";
         break;
       case TremoloKey::neighbors :
         writeNeighbors(file, atoi(it->substr(it->find("=") + 1, 1).c_str()), currentAtom);
         break;
+      case TremoloKey::resSeq :
+        if (additionalAtomData.find(currentAtom->getId()) != additionalAtomData.end()) {
+          *file << additionalAtomData[currentAtom->getId()].get(currentField);
+        } else if (currentAtom->getMolecule() != NULL) {
+          *file << setw(4) << currentAtom->getMolecule()->getId()+1;
+        } else {
+          *file << defaultAdditionalData.get(currentField);
+        }
+        *file << "\t";
+      break;
       default :
-        *file << (additionalAtomData.find(currentAtom->getId()) != additionalAtomData.end()
-          ? additionalAtomData[currentAtom->getId()].get(currentField)
-          : defaultAdditionalData.get(currentField));
+        if (additionalAtomData.find(currentAtom->getId()) != additionalAtomData.end()) {
+          *file << additionalAtomData[currentAtom->getId()].get(currentField);
+        } else if (additionalAtomData.find(currentAtom->GetTrueFather()->getId()) != additionalAtomData.end()) {
+          *file << additionalAtomData[currentAtom->GetTrueFather()->getId()].get(currentField);
+        } else {
+          *file << defaultAdditionalData.get(currentField);
+        }
         *file << "\t";
         break;
@@ -182,5 +215,7 @@
   for (int i = 0; i < numberOfNeighbors; i++) {
     *file << (currentBond != currentAtom->ListOfBonds.end()
-        ? (*currentBond)->GetOtherAtom(currentAtom)->getId() : 0) << "\t";
+        ? (*currentBond)->GetOtherAtom(currentAtom)->getId()+1 : 0) << "\t";
+    if (currentBond != currentAtom->ListOfBonds.end())
+      currentBond++;
   }
 }
@@ -214,6 +249,7 @@
  *
  * \param line to parse as an atom
- */
-void TremoloParser::readAtomDataLine(string line) {
+ * \param *newmol molecule to add atom to
+ */
+void TremoloParser::readAtomDataLine(string line, molecule *newmol = NULL) {
   vector<string>::iterator it;
   stringstream lineStream;
@@ -225,4 +261,5 @@
   string word;
   int oldId;
+  double tmp;
 
   lineStream << line;
@@ -232,13 +269,14 @@
       case TremoloKey::x :
         // for the moment, assume there are always three dimensions
-        lineStream >> newAtom->x[0];
-        lineStream >> newAtom->x[1];
-        lineStream >> newAtom->x[2];
+        for (int i=0;i<NDIM;i++) {
+          lineStream >> tmp;
+          newAtom->set(i, tmp);
+        }
         break;
       case TremoloKey::u :
         // for the moment, assume there are always three dimensions
-        lineStream >> newAtom->v[0];
-        lineStream >> newAtom->v[1];
-        lineStream >> newAtom->v[2];
+        lineStream >> newAtom->AtomicVelocity[0];
+        lineStream >> newAtom->AtomicVelocity[1];
+        lineStream >> newAtom->AtomicVelocity[2];
         break;
       case TremoloKey::Type :
@@ -262,4 +300,6 @@
     }
   }
+  if (newmol != NULL)
+    newmol->AddAtom(newAtom);
 }
 
@@ -385,23 +425,23 @@
 
 
-TremoloAtomInfoContainer::TremoloAtomInfoContainer() {
-  F = "0";
-  stress = "0";
-  imprData = "-";
-  GroupMeasureTypeNo = "0";
-  extType = "-";
-  name = "-";
-  resName = "-";
-  chainID = "0";
-  resSeq = "0";
-  occupancy = "0";
-  tempFactor = "0";
-  segID = "0";
-  Charge = "0";
-  charge = "0";
-  GrpTypeNo = "0";
-  torsion = "-";
-  neighbors = vector<int>(0, 5);
-}
+TremoloAtomInfoContainer::TremoloAtomInfoContainer() :
+  F("0"),
+  stress("0"),
+  imprData("-"),
+  GroupMeasureTypeNo("0"),
+  extType("-"),
+  name("-"),
+  resName("-"),
+  chainID("0"),
+  resSeq("0"),
+  occupancy("0"),
+  tempFactor("0"),
+  segID("0"),
+  Charge("0"),
+  charge("0"),
+  GrpTypeNo("0"),
+  torsion("-"),
+  neighbors(vector<int>(0, 5))
+{}
 
 void TremoloAtomInfoContainer::set(TremoloKey::atomDataKey key, string value) {
Index: src/Parser/TremoloParser.hpp
===================================================================
--- src/Parser/TremoloParser.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Parser/TremoloParser.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,4 +11,6 @@
 #include <string>
 #include "Parser/FormatParser.hpp"
+
+class molecule;
 
 /**
@@ -85,4 +87,5 @@
 private:
   void readAtomDataLine(string line);
+  void readAtomDataLine(string line, molecule *newmol);
   void parseAtomDataKeysLine(string line, int offset);
   void readNeighbors(std::stringstream* line, int numberOfNeighbors, int atomId);
Index: src/Parser/XyzParser.cpp
===================================================================
--- src/Parser/XyzParser.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Parser/XyzParser.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * XyzParser.cpp
@@ -6,9 +13,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "XyzParser.hpp"
 #include "World.hpp"
 #include "atom.hpp"
+#include "molecule.hpp"
 #include "element.hpp"
 #include "periodentafel.hpp"
@@ -19,7 +34,7 @@
  * Constructor.
  */
-XyzParser::XyzParser() {
-  comment = "";
-}
+XyzParser::XyzParser() :
+  comment("")
+{}
 
 /**
@@ -35,7 +50,9 @@
  */
 void XyzParser::load(istream* file) {
-  atom* newAtom;
+  atom* newAtom = NULL;
+  molecule* newmol = NULL;
   int numberOfAtoms;
   char commentBuffer[512], type[3];
+  double tmp;
 
   // the first line tells number of atoms, the second line is always a comment
@@ -44,8 +61,17 @@
   comment = commentBuffer;
 
+  newmol = World::getInstance().createMolecule();
+  newmol->ActiveFlag = true;
+  // TODO: Remove the insertion into molecule when saving does not depend on them anymore. Also, remove molecule.hpp include
+  World::getInstance().getMolecules()->insert(newmol);
   for (int i = 0; i < numberOfAtoms; i++) {
     newAtom = World::getInstance().createAtom();
-    *file >> type >> ws >> newAtom->x[0] >> ws >> newAtom->x[1] >> ws >> newAtom->x[2];
+    *file >> type;
+    for (int j=0;j<NDIM;j++) {
+      *file >> tmp;
+      newAtom->set(j, tmp);
+    }
     newAtom->setType(World::getInstance().getPeriode()->FindElement(type));
+    newmol->AddAtom(newAtom);
   }
 }
@@ -57,4 +83,5 @@
  */
 void XyzParser::save(ostream* file) {
+  DoLog(0) && (Log() << Verbose(0) << "Saving changes to xyz." << std::endl);
   if (comment == "") {
     time_t now = time((time_t *)NULL);   // Get the system time and put it into 'now' as 'calender time'
@@ -72,5 +99,5 @@
   vector<atom*> atoms = World::getInstance().getAllAtoms();
   for(vector<atom*>::iterator it = atoms.begin(); it != atoms.end(); it++) {
-    *file << noshowpoint << (*it)->getType()->symbol << "\t" << (*it)->x[0] << "\t" << (*it)->x[1] << "\t" << (*it)->x[2] << endl;
+    *file << noshowpoint << (*it)->getType()->getSymbol() << "\t" << (*it)->at(0) << "\t" << (*it)->at(1) << "\t" << (*it)->at(2) << endl;
   }
 }
Index: src/Patterns/ObservedContainer_impl.hpp
===================================================================
--- src/Patterns/ObservedContainer_impl.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Patterns/ObservedContainer_impl.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -186,3 +186,30 @@
 }
 
+/************ Explicit instantiation ***************/
+
+#define CONSTRUCT_OBSERVEDCONTAINER(name) \
+    template ObservedContainer< name >& ObservedContainer< name >::operator=(const ObservedContainer< name >&); \
+    template ObservedContainer< name >::iterator ObservedContainer< name >::begin(); \
+    template ObservedContainer< name >::const_iterator ObservedContainer< name >::begin() const; \
+    template ObservedContainer< name >::iterator ObservedContainer< name >::end(); \
+    template ObservedContainer< name >::const_iterator ObservedContainer< name >::end() const; \
+    template ObservedContainer< name >::reverse_iterator ObservedContainer< name >::rbegin(); \
+    template ObservedContainer< name >::const_reverse_iterator ObservedContainer< name >::rbegin() const; \
+    template ObservedContainer< name >::reverse_iterator ObservedContainer< name >::rend(); \
+    template ObservedContainer< name >::const_reverse_iterator ObservedContainer< name >::rend() const; \
+    template bool ObservedContainer< name >::empty() const; \
+    template size_t ObservedContainer< name >::size() const; \
+    template size_t ObservedContainer< name >::max_size() const; \
+    template ObservedContainer< name >::mapped_type &ObservedContainer< name >::operator[](const key_type&); \
+    template std::pair<ObservedContainer< name >::iterator,bool> ObservedContainer< name >::insert (const value_type&); \
+    template size_t ObservedContainer< name >::erase ( const key_type& x ); \
+    template void ObservedContainer< name >::clear(); \
+    template ObservedContainer< name >::iterator ObservedContainer< name >::find ( const key_type& x ); \
+    template ObservedContainer< name >::const_iterator ObservedContainer< name >::find ( const key_type& x ) const; \
+    template size_t ObservedContainer< name >::count ( const key_type& x ) const; \
+    template ObservedContainer< name >::internal_iterator ObservedContainer< name >::begin_internal(); \
+    template ObservedContainer< name >::reverse_internal_iterator ObservedContainer< name >::rbegin_internal(); \
+    template ObservedContainer< name >::internal_iterator ObservedContainer< name >::end_internal(); \
+    template ObservedContainer< name >::reverse_internal_iterator ObservedContainer< name >::rend_internal(); \
+
 #endif /* OBSERVEDCONTAINER_IMPL_HPP_ */
Index: src/Patterns/Observer.cpp
===================================================================
--- src/Patterns/Observer.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Patterns/Observer.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * Observer.cpp
@@ -6,8 +13,12 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Observer.hpp"
-
 
 #include <iostream>
Index: src/Patterns/Registry_impl.hpp
===================================================================
--- src/Patterns/Registry_impl.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Patterns/Registry_impl.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -15,5 +15,5 @@
 
 #include "Helpers/Assert.hpp"
-#include <iostream>
+#include <iosfwd>
 
 /** Constructor for class Registry.
Index: src/PointCloud.cpp
===================================================================
--- src/PointCloud.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/PointCloud.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,39 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * PointCloud.cpp
+ *
+ *  Created on: Jul 29, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "PointCloud.hpp"
+
+/** Constructor of class PointCloud.
+ */
+PointCloud::PointCloud()
+{
+  //Info FunctionInfo(__func__);
+}
+;
+
+/** Destructor for class PointCloud.
+ */
+PointCloud::~PointCloud()
+{
+  //Info FunctionInfo(__func__);
+}
+;
+
Index: src/PointCloud.hpp
===================================================================
--- src/PointCloud.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/PointCloud.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,35 @@
+/*
+ * PointCloud.hpp
+ *
+ *  Created on: Jul 29, 2010
+ *      Author: heber
+ */
+
+#ifndef POINTCLOUD_HPP_
+#define POINTCLOUD_HPP_
+
+#include <cstdio>
+
+class TesselPoint;
+class Vector;
+
+/** Super-class for all point clouds structures, also molecules. They have to inherit this structure and implement the virtual function to access the Vectors.
+ * This basically encapsulates a list structure.
+ */
+class PointCloud {
+public:
+  PointCloud();
+  virtual ~PointCloud();
+
+  virtual const char * const GetName() const { return "unknown"; };
+  virtual Vector *GetCenter() const { return NULL; };
+  virtual TesselPoint *GetPoint() const { return NULL; };
+  virtual int GetMaxId() const { return 0; };
+  virtual void GoToNext() const {};
+  virtual void GoToFirst() const {};
+  virtual bool IsEmpty() const { return true; };
+  virtual bool IsEnd() const { return true; };
+};
+
+
+#endif /* POINTCLOUD_HPP_ */
Index: src/Shapes/BaseShapes.cpp
===================================================================
--- src/Shapes/BaseShapes.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Shapes/BaseShapes.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * BaseShapes_impl.cpp
@@ -6,12 +13,82 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
 #include "Shapes/BaseShapes.hpp"
 #include "Shapes/BaseShapes_impl.hpp"
-
-#include "vector.hpp"
+#include "Shapes/ShapeOps.hpp"
+
+#include "defs.hpp"
+
+#include "Helpers/Assert.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Line.hpp"
+#include "LinearAlgebra/Plane.hpp"
+#include "LinearAlgebra/LineSegment.hpp"
+#include "LinearAlgebra/LineSegmentSet.hpp"
+
+#include <cmath>
+#include <algorithm>
 
 bool Sphere_impl::isInside(const Vector &point){
   return point.NormSquared()<=1;
 }
+
+bool Sphere_impl::isOnSurface(const Vector &point){
+  return fabs(point.NormSquared()-1)<MYEPSILON;
+}
+
+Vector Sphere_impl::getNormal(const Vector &point) throw(NotOnSurfaceException){
+  if(!isOnSurface(point)){
+    throw NotOnSurfaceException(__FILE__,__LINE__);
+  }
+  return point;
+}
+
+LineSegmentSet Sphere_impl::getLineIntersections(const Line &line){
+  LineSegmentSet res(line);
+  std::vector<Vector> intersections = line.getSphereIntersections();
+  if(intersections.size()==2){
+    res.insert(LineSegment(intersections[0],intersections[1]));
+  }
+  return res;
+}
+
+string Sphere_impl::toString(){
+  return "Sphere()";
+}
+
+/**
+ * algorithm taken from http://www.cgafaq.info/wiki/Evenly_distributed_points_on_sphere
+ * \param N number of points on surface
+ */
+std::vector<Vector> Sphere_impl::getHomogeneousPointsOnSurface(const size_t N) const {
+  std::vector<Vector> PointsOnSurface;
+
+  const double dlength = M_PI*(3.-sqrt(5.));
+  double length = 0;
+  const double dz = 2.0/N;
+  double z = 1. - dz/2.;
+  Vector point;
+  for (size_t ka = 0; ka<N; ka++){
+    const double r = sqrt(1.-z*z);
+    point.Zero();
+    point[0] = cos(length)*r;
+    point[1] = sin(length)*r;
+    point[2] = z;
+    PointsOnSurface.push_back(point);
+    z = z - dz;
+    length = length + dlength;
+  }
+
+  ASSERT(PointsOnSurface.size() == N, "Sphere_impl::getHomogeneousPointsOnSurface() did not create enough points.");
+  return PointsOnSurface;
+}
+
 
 Shape Sphere(){
@@ -20,10 +97,105 @@
 }
 
+Shape Sphere(const Vector &center,double radius){
+  return translate(resize(Sphere(),radius),center);
+}
+
+Shape Ellipsoid(const Vector &center, const Vector &radius){
+  return translate(stretch(Sphere(),radius),center);
+}
+
 bool Cuboid_impl::isInside(const Vector &point){
-  return point[0]<=1 && point[1]<=1 && point[2]<=1;
+  return (point[0]>=0 && point[0]<=1) && (point[1]>=0 && point[1]<=1) && (point[2]>=0 && point[2]<=1);
+}
+
+bool Cuboid_impl::isOnSurface(const Vector &point){
+  bool retVal = isInside(point);
+  // test all borders of the cuboid
+  // double fabs
+  retVal = retVal &&
+           (((fabs(point[0]-1.)  < MYEPSILON) || (fabs(point[0])  < MYEPSILON)) ||
+            ((fabs(point[1]-1.)  < MYEPSILON) || (fabs(point[1])  < MYEPSILON)) ||
+            ((fabs(point[2]-1.)  < MYEPSILON) || (fabs(point[2])  < MYEPSILON)));
+  return retVal;
+}
+
+Vector Cuboid_impl::getNormal(const Vector &point) throw(NotOnSurfaceException){
+  if(!isOnSurface(point)){
+    throw NotOnSurfaceException(__FILE__,__LINE__);
+  }
+  Vector res;
+  // figure out on which sides the Vector lies (maximum 3, when it is in a corner)
+  for(int i=NDIM;i--;){
+    if(fabs(fabs(point[i])-1)<MYEPSILON){
+      // add the scaled (-1/+1) Vector to the set of surface vectors
+      res[i] = point[i];
+    }
+  }
+  ASSERT(res.NormSquared()>=1 && res.NormSquared()<=3,"To many or to few sides found for this Vector");
+
+  res.Normalize();
+  return res;
+}
+
+LineSegmentSet Cuboid_impl::getLineIntersections(const Line &line){
+  LineSegmentSet res(line);
+  // get the intersection on each of the six faces
+  vector<Vector> intersections;
+  intersections.resize(2);
+  int c=0;
+  int x[2]={-1,+1};
+  for(int i=NDIM;i--;){
+    for(int p=0;p<2;++p){
+      if(c==2) goto end; // I know this sucks, but breaking two loops is stupid
+      Vector base;
+      base[i]=x[p];
+      // base now points to the surface and is normal to it at the same time
+      Plane p(base,base);
+      Vector intersection = p.GetIntersection(line);
+      if(isInside(intersection)){
+        // if we have a point on the edge it might already be contained
+        if(c==1 && intersections[0]==intersection)
+          continue;
+        intersections[c++]=intersection;
+      }
+    }
+  }
+  end:
+  if(c==2){
+    res.insert(LineSegment(intersections[0],intersections[1]));
+  }
+  return res;
+}
+
+string Cuboid_impl::toString(){
+  return "Cuboid()";
+}
+
+/**
+ * \param N number of points on surface
+ */
+std::vector<Vector> Cuboid_impl::getHomogeneousPointsOnSurface(const size_t N) const {
+  std::vector<Vector> PointsOnSurface;
+  ASSERT(false, "Cuboid_impl::getHomogeneousPointsOnSurface() not implemented yet");
+  return PointsOnSurface;
 }
 
 Shape Cuboid(){
-  Shape::impl_ptr impl = Shape::impl_ptr(new Sphere_impl());
+  Shape::impl_ptr impl = Shape::impl_ptr(new Cuboid_impl());
   return Shape(impl);
 }
+
+Shape Cuboid(const Vector &corner1, const Vector &corner2){
+  // make sure the two edges are upper left front and lower right back
+  Vector sortedC1;
+  Vector sortedC2;
+  for(int i=NDIM;i--;){
+    sortedC1[i] = min(corner1[i],corner2[i]);
+    sortedC2[i] = max(corner1[i],corner2[i]);
+    ASSERT(corner1[i]!=corner2[i],"Given points for cuboid edges did not define a valid space");
+  }
+  // get the middle point
+  Vector middle = (1./2.)*(sortedC1+sortedC2);
+  Vector factors = sortedC2-middle;
+  return translate(stretch(Cuboid(),factors),middle);
+}
Index: src/Shapes/BaseShapes.hpp
===================================================================
--- src/Shapes/BaseShapes.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Shapes/BaseShapes.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -12,5 +12,8 @@
 
 Shape Sphere();
+Shape Sphere(const Vector &center,double radius);
+Shape Ellipsoid(const Vector &center, const Vector &radius);
 Shape Cuboid();
+Shape Cuboid(const Vector &corner1, const Vector &corner2);
 
 #endif /* BASESHAPES_HPP_ */
Index: src/Shapes/BaseShapes_impl.hpp
===================================================================
--- src/Shapes/BaseShapes_impl.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Shapes/BaseShapes_impl.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -9,12 +9,25 @@
 #define BASESHAPES_IMPL_HPP_
 
+class Vector;
+class LineSegmentSet;
+
 #include "Shapes/Shape_impl.hpp"
 
 class Sphere_impl : public Shape_impl {
   virtual bool isInside(const Vector &point);
+  virtual bool isOnSurface(const Vector &point);
+  virtual Vector getNormal(const Vector &point) throw(NotOnSurfaceException);
+  virtual LineSegmentSet getLineIntersections(const Line&);
+  virtual std::string toString();
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
 };
 
 class Cuboid_impl : public Shape_impl {
   virtual bool isInside(const Vector &point);
+  virtual bool isOnSurface(const Vector &point);
+  virtual Vector getNormal(const Vector &point) throw(NotOnSurfaceException);
+  virtual LineSegmentSet getLineIntersections(const Line&);
+  virtual std::string toString();
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
 };
 
